---
- name: Provision K8S-master
  hosts: "*"
  become: true
  tasks: 

    - name: Include task list in play
      include_tasks: common-playbook.yml

    - name: Create Master k8s node
      raw: kubeadm init --cri-socket "/var/run/crio/crio.sock"  --apiserver-advertise-address="{{ master_ip }}" --pod-network-cidr=10.244.0.0/16

    - name: Remove file (delete file)
      file:
        path: /vagrant/join.sh
        state: absent    

    - name: Creating join file command for K8s Nodes
      raw: kubeadm token create --print-join-command | grep "kubeadm join" > /vagrant/join.sh

    - name: change the execute permission on the join.sh file
      file:
        path: /vagrant/join.sh
        state: touch
        mode: "+x"

    - name: Add debug switch to join command
      raw: sed -i '$ s/$/ --v=6/' /vagrant/join.sh
    
    - name: Create .kube directory if it does not exist
      file:
        path: $HOME/.kube
        state: directory
        mode: '0777'
    
    - name: Copy K8S config to .kube folder
      raw: cp -i /etc/kubernetes/admin.conf $HOME/.kube/config

    - name: Set Owner of K8S config file
      raw: sudo chown $(id -u):$(id -g) $HOME/.kube/config

#   We may need this in the future -this will error out 
    - name: Config KUBLET_EXTRA_ARGS
      shell:
        cmd: echo 'Environment="KUBELET_EXTRA_ARGS=--node-ip={{ master_ip }}"' | sudo tee -a /usr/lib/systemd/system/kubelet.service.d/10-kubeadm.conf
      args:
        executable: /bin/bash

    - name: apply calico pod networking
      raw: kubectl apply -f https://docs.projectcalico.org/v3.14/manifests/calico.yaml

    - name: reload systemd
      command: systemctl daemon-reload

    - name: Restart Kubelet
      command: systemctl restart kubelet

    - name: Reboot the machine
      reboot:
        reboot_timeout: 3600
